diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/rounding_view_to_nearest_selected.xpm lmi-editor/rounding_view_to_nearest_selected.xpm
--- cvs/rounding_view_to_nearest_selected.xpm	1970-01-01 01:00:00.000000000 +0100
+++ lmi-editor/rounding_view_to_nearest_selected.xpm	2008-02-08 15:12:05.000000000 +0100
@@ -0,0 +1,69 @@
+/* XPM */
+static char const* rounding_view_to_nearest_selected_xpm[] = {
+"16 16 50 1",
+" 	c None",
+"!	c #003C74",
+"#	c #A1BEED",
+"$	c #96B1DD",
+"%	c #2A323E",
+"&	c black",
+"'	c #29303B",
+"(	c #92AAD2",
+")	c #9FBBE9",
+"*	c #536179",
+"+	c #9DB8E4",
+",	c #A0BDEB",
+"-	c #404B5D",
+".	c #0A0C0F",
+"0	c #4D576A",
+"1	c #090B0D",
+"2	c #1D2128",
+"3	c #98B0D9",
+"4	c #8AA1C9",
+"5	c #586479",
+"6	c #95ACD2",
+"7	c #9EBAE7",
+"8	c #15181E",
+"9	c #3A4251",
+":	c #8B9CBB",
+";	c #5D697F",
+"<	c #303641",
+"=	c #323A47",
+">	c #7987A3",
+"?	c #93A8CD",
+"@	c #4C5567",
+"A	c #8FA1C3",
+"B	c #96ADD5",
+"C	c #58657B",
+"D	c #090A0D",
+"E	c #535E70",
+"F	c #8D9EBE",
+"G	c #97AFD7",
+"H	c #A0BCEA",
+"I	c #9BB5E0",
+"J	c #92A6CB",
+"K	c #95ABD1",
+"L	c #9CB6E2",
+"M	c #94A9CF",
+"N	c #8EA0C1",
+"O	c #94AACF",
+"P	c #9DB7E3",
+"Q	c #9FBBE8",
+"R	c #9DB8E5",
+"S	c #9AB4DE",
+"!!!!!!!!!!!!!!!!",
+"!##############!",
+"!##############!",
+"!##############!",
+"!##############!",
+"!##############!",
+"!###$%&'()#&*+,!",
+"!###-.01234&567!",
+"!###89:;&<=&>?7!",
+"!###&@ABCDDEFGH!",
+"!###IJK+LMNNOP#!",
+"!###QL+,,RSSR,#!",
+"!##############!",
+"!##############!",
+"!##############!",
+"!!!!!!!!!!!!!!!!"};
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/rounding_view_to_nearest.xpm lmi-editor/rounding_view_to_nearest.xpm
--- cvs/rounding_view_to_nearest.xpm	1970-01-01 01:00:00.000000000 +0100
+++ lmi-editor/rounding_view_to_nearest.xpm	2008-02-08 15:12:05.000000000 +0100
@@ -0,0 +1,69 @@
+/* XPM */
+static char const* rounding_view_to_nearest_xpm[] = {
+"16 16 50 1",
+" 	c None",
+"!	c #ECE9D8",
+"#	c #DCD9CA",
+"$	c #3E3D39",
+"%	c black",
+"&	c #3A3936",
+"'	c #CFCDC1",
+"(	c #E7E5D5",
+")	c #76756E",
+"*	c #E1DFD1",
+"+	c #EAE7D6",
+",	c #5D5C55",
+"-	c #0E0E0D",
+".	c #666663",
+"0	c #0C0C0C",
+"1	c #262625",
+"2	c #D4D3C8",
+"3	c #C7C5B8",
+"4	c #747471",
+"5	c #CDCCC3",
+"6	c #E5E2D3",
+"7	c #1E1E1C",
+"8	c #4E4E4B",
+"9	c #B2B2B1",
+":	c #787977",
+";	c #3E3E3D",
+"<	c #454542",
+"=	c #9A9B99",
+">	c #C6C5BF",
+"?	c #626261",
+"@	c #BABAB6",
+"A	c #D0CEC5",
+"B	c #777672",
+"C	c #6B6B6A",
+"D	c #B5B5B3",
+"E	c #D2D0C6",
+"F	c #E8E5D5",
+"G	c #DCDACD",
+"H	c #C3C3BD",
+"I	c #CBCAC2",
+"J	c #E2DFD1",
+"K	c #DEDCCF",
+"L	c #C8C7C0",
+"M	c #B8B8B5",
+"N	c #C9C8C0",
+"O	c #E0DED0",
+"P	c #E6E4D4",
+"Q	c #EAE7D7",
+"R	c #E2E0D1",
+"S	c #DAD8CC",
+"!!!!!!!!!!!!!!!!",
+"!!!!!!!!!!!!!!!!",
+"!!!!!!!!!!!!!!!!",
+"!!!!!!!!!!!!!!!!",
+"!!!!!!!!!!!!!!!!",
+"!!!!!!!!!!!!!!!!",
+"!!!!#$%&'(!%)*+!",
+"!!!!,-.0123%456!",
+"!!!!789:%;<%=>6!",
+"!!!!%?@AB00CDEF!",
+"!!!!GHIJKLMMNO!!",
+"!!!!PK*+QRSSRQ!!",
+"!!!!!!!!!!!!!!!!",
+"!!!!!!!!!!!!!!!!",
+"!!!!!!!!!!!!!!!!",
+"!!!!!!!!!!!!!!!!"};
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/rounding_view_upward_hover.xpm lmi-editor/rounding_view_upward_hover.xpm
--- cvs/rounding_view_upward_hover.xpm	1970-01-01 01:00:00.000000000 +0100
+++ lmi-editor/rounding_view_upward_hover.xpm	2008-02-08 15:12:05.000000000 +0100
@@ -0,0 +1,78 @@
+/* XPM */
+static char const* rounding_view_upward_hover_xpm[] = {
+"16 16 59 1",
+" 	c None",
+"!	c #82BB91",
+"#	c #D1F6DF",
+"$	c #C3E6D0",
+"%	c #B4D4C0",
+"&	c #D0F4DE",
+"'	c #29302C",
+"(	c #0D0F0E",
+")	c #9BB4A7",
+"*	c #CAEDD9",
+"+	c #D0F5DE",
+",	c #526158",
+"-	c #222726",
+".	c #222625",
+"0	c #AEC9BD",
+"1	c #CBEEDA",
+"2	c #7D9285",
+"3	c black",
+"4	c #687772",
+"5	c #81918E",
+"6	c #0B0C0C",
+"7	c #444E4B",
+"8	c #BFDDCE",
+"9	c #CEF2DC",
+":	c #96B0A1",
+";	c #899F95",
+"<	c #899C96",
+"=	c #73837E",
+">	c #8CA099",
+"?	c #7D8F89",
+"@	c #ABC5B9",
+"A	c #CAECD8",
+"B	c #CDF1DB",
+"C	c #A8C3B5",
+"D	c #0C0E0D",
+"E	c #778881",
+"F	c #B6D1C5",
+"G	c #BFDECE",
+"H	c #282F2B",
+"I	c #191C1B",
+"J	c #373E3C",
+"K	c #9BB2A8",
+"L	c #C5E6D4",
+"M	c #CEF3DD",
+"N	c #899B96",
+"O	c #97AAA7",
+"P	c #161818",
+"Q	c #CCEFDA",
+"R	c #BBD8CA",
+"S	c #AEC6BE",
+"T	c #B7D2C6",
+"U	c #B9D6C8",
+"V	c #AFC8BF",
+"W	c #C8EAD7",
+"X	c #C8E9D6",
+"Y	c #C5E5D3",
+"Z	c #CBEED9",
+"[	c #C6E7D4",
+"]	c #C6E7D5",
+"!!!!!!!!!!!!!!!!",
+"!##############!",
+"!##############!",
+"!######$%&#####!",
+"!#####$'()*+###!",
+"!#####,(-.01###!",
+"!####23456789##!",
+"!####:;<=>?@A##!",
+"!####BCD3EFG1##!",
+"!####+HIJ6KLM##!",
+"!####,3NOP.0Q##!",
+"!####QRSTUVFW##!",
+"!####MXYZQ[]B##!",
+"!##############!",
+"!##############!",
+"!!!!!!!!!!!!!!!!"};
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/rounding_view_upward_selected.xpm lmi-editor/rounding_view_upward_selected.xpm
--- cvs/rounding_view_upward_selected.xpm	1970-01-01 01:00:00.000000000 +0100
+++ lmi-editor/rounding_view_upward_selected.xpm	2008-02-08 15:12:05.000000000 +0100
@@ -0,0 +1,79 @@
+/* XPM */
+static char const* rounding_view_upward_selected_xpm[] = {
+"16 16 60 1",
+" 	c None",
+"!	c #003C74",
+"#	c #A1BEED",
+"$	c #96B1DD",
+"%	c #8BA4CD",
+"&	c #A0BDEB",
+"'	c #20252E",
+"(	c #0A0C0F",
+")	c #7B8FB0",
+"*	c #9EB9E5",
+"+	c #A1BDEC",
+",	c #404B5D",
+"-	c #1D2027",
+".	c #1C2027",
+"0	c #8CA1C6",
+"1	c #9EBAE7",
+"2	c #60718D",
+"3	c black",
+"4	c #566277",
+"5	c #6E7B93",
+"6	c #090A0C",
+"7	c #39404E",
+"8	c #98B0D9",
+"9	c #9FBCE9",
+":	c #7588AA",
+";	c #6F809C",
+"<	c #72829D",
+"=	c #606D84",
+">	c #7484A0",
+"?	c #69778F",
+"@	c #8BA0C2",
+"A	c #9FBBE9",
+"B	c #859BBF",
+"C	c #0A0B0E",
+"D	c #616F87",
+"E	c #94A9CF",
+"F	c #99B1DA",
+"G	c #A0BDEC",
+"H	c #1F252E",
+"I	c #14171C",
+"J	c #2F343F",
+"K	c #7F91B1",
+"L	c #9BB5E0",
+"M	c #A0BCEA",
+"N	c #404B5E",
+"O	c #72819C",
+"P	c #8291AE",
+"Q	c #131519",
+"R	c #1C2026",
+"S	c #9FBAE7",
+"T	c #96ADD4",
+"U	c #90A4C7",
+"V	c #94AAD0",
+"W	c #96ACD3",
+"X	c #91A5C8",
+"Y	c #94AACF",
+"Z	c #9DB8E3",
+"[	c #9DB7E3",
+"]	c #9EB9E6",
+"^	c #9CB6E1",
+"!!!!!!!!!!!!!!!!",
+"!##############!",
+"!##############!",
+"!######$%&#####!",
+"!#####$'()*+###!",
+"!#####,(-.01###!",
+"!####23456789##!",
+"!####:;<=>?@*##!",
+"!####ABC3DEF1##!",
+"!####GHIJ6KLM##!",
+"!####N3OPQR0S##!",
+"!####STUVWXYZ##!",
+"!####M[L]S^^A##!",
+"!##############!",
+"!##############!",
+"!!!!!!!!!!!!!!!!"};
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/rounding_view_upward.xpm lmi-editor/rounding_view_upward.xpm
--- cvs/rounding_view_upward.xpm	1970-01-01 01:00:00.000000000 +0100
+++ lmi-editor/rounding_view_upward.xpm	2008-02-08 15:12:05.000000000 +0100
@@ -0,0 +1,80 @@
+/* XPM */
+static char const* rounding_view_upward_xpm[] = {
+"16 16 61 1",
+" 	c None",
+"!	c #ECE9D8",
+"#	c #DCD9CA",
+"$	c #CCC9BA",
+"%	c #EAE7D7",
+"&	c #2E2D2A",
+"'	c #0F0E0E",
+"(	c #ADACA2",
+")	c #E3E1D2",
+"*	c #EBE8D7",
+"+	c #5D5C55",
+",	c #0E0E0D",
+"-	c #252525",
+".	c #252524",
+"0	c #C1BFB7",
+"1	c #E5E2D3",
+"2	c #8C8B81",
+"3	c black",
+"4	c #737370",
+"5	c #8B8C8B",
+"6	c #0C0C0C",
+"7	c #4B4A49",
+"8	c #D5D3C8",
+"9	c #E8E5D5",
+":	c #A9A69B",
+";	c #999890",
+"<	c #969692",
+"=	c #7F7F7B",
+">	c #9A9A96",
+"?	c #898986",
+"@	c #BDBCB4",
+"A	c #E3E0D2",
+"B	c #E7E4D5",
+"C	c #BBBAB0",
+"D	c #0D0D0D",
+"E	c #83837E",
+"F	c #C9C8C0",
+"G	c #D5D3C9",
+"H	c #2D2D2A",
+"I	c #1B1B1A",
+"J	c #3C3C3B",
+"K	c #ABAAA5",
+"L	c #DDDBCE",
+"M	c #E9E6D6",
+"N	c #5D5C56",
+"O	c #969592",
+"P	c #A3A4A3",
+"Q	c #171817",
+"R	c #242424",
+"S	c #E5E3D4",
+"T	c #CFCEC5",
+"U	c #BFBEBA",
+"V	c #CAC9C1",
+"W	c #CDCCC3",
+"X	c #C0C0BB",
+"Y	c #E1DED0",
+"Z	c #E0DED0",
+"[	c #DCDACD",
+"]	c #E4E2D3",
+"^	c #DEDBCE",
+"_	c #DEDCCF",
+"!!!!!!!!!!!!!!!!",
+"!!!!!!!!!!!!!!!!",
+"!!!!!!!!!!!!!!!!",
+"!!!!!!!#$%!!!!!!",
+"!!!!!!#&'()*!!!!",
+"!!!!!!+,-.01!!!!",
+"!!!!!23456789!!!",
+"!!!!!:;<=>?@A!!!",
+"!!!!!BCD3EFG1!!!",
+"!!!!!*HIJ6KLM!!!",
+"!!!!!N3OPQR0S!!!",
+"!!!!!STUVWXFY!!!",
+"!!!!!MZ[]S^_B!!!",
+"!!!!!!!!!!!!!!!!",
+"!!!!!!!!!!!!!!!!",
+"!!!!!!!!!!!!!!!!"};
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/rounding_view.xrc lmi-editor/rounding_view.xrc
--- cvs/rounding_view.xrc	2008-01-10 18:31:47.000000000 +0100
+++ lmi-editor/rounding_view.xrc	2008-01-30 21:04:28.000000000 +0100
@@ -28,12 +28,34 @@
 -->
 
 <object class="wxPanel" name="rounding_view_panel">
+    
+<object class="wxBoxSizer">
+    <orient>wxHORIZONTAL</orient>
+    <object class="spacer">
+        <option>1</option>
+    </object>
+    <object class="sizeritem">
+        <flag>wxALIGN_CENTER|wxALIGN_CENTER_VERTICAL</flag>
+        <option>0</option>
+
+<object class="wxBoxSizer">
+    <orient>wxHORIZONTAL</orient>
+    <object class="sizeritem">
+        <flag>wxALIGN_LEFT|wxALIGN_TOP|wxBOTTOM|wxLEFT|wxRIGHT</flag>
+        <border>6</border>
+        <object class="wxStaticBoxSizer">
+            <orient>wxVERTICAL</orient>
+            <object class="sizeritem">
+                <flag>wxALL</flag>
+                <border>4</border>
     <object class="wxFlexGridSizer">
         <cols>2</cols>
-        <growablerows>1</growablerows>
+        <rows>0</rows>
+        <hgap>8</hgap>
+        <vgap>4</vgap>
 
         <object class="sizeritem">
-            <flag>wxALIGN_LEFT</flag>
+            <flag>wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL</flag>
             <object class="wxStaticText">
                 <label>specamt</label>
             </object>
@@ -41,14 +63,13 @@
         <object class="sizeritem">
             <flag>wxALIGN_LEFT</flag>
             <object class="RoundingButtons" name="specamt">
-                <size>-1,-1</size>
             </object>
         </object>
 
         <object class="sizeritem">
-            <flag>wxALIGN_LEFT</flag>
+            <flag>wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL</flag>
             <object class="wxStaticText">
-                <label>death_benefit</label>
+                <label>death benefit</label>
             </object>
         </object>
         <object class="sizeritem">
@@ -59,7 +80,7 @@
         </object>
 
         <object class="sizeritem">
-            <flag>wxALIGN_LEFT</flag>
+            <flag>wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL</flag>
             <object class="wxStaticText">
                 <label>naar</label>
             </object>
@@ -72,9 +93,9 @@
         </object>
 
         <object class="sizeritem">
-            <flag>wxALIGN_LEFT</flag>
+            <flag>wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL</flag>
             <object class="wxStaticText">
-                <label>coi_rate</label>
+                <label>coi rate</label>
             </object>
         </object>
         <object class="sizeritem">
@@ -85,9 +106,9 @@
         </object>
 
         <object class="sizeritem">
-            <flag>wxALIGN_LEFT</flag>
+            <flag>wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL</flag>
             <object class="wxStaticText">
-                <label>coi_charge</label>
+                <label>coi charge</label>
             </object>
         </object>
         <object class="sizeritem">
@@ -98,9 +119,9 @@
         </object>
 
         <object class="sizeritem">
-            <flag>wxALIGN_LEFT</flag>
+            <flag>wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL</flag>
             <object class="wxStaticText">
-                <label>gross_premium</label>
+                <label>gross premium</label>
             </object>
         </object>
         <object class="sizeritem">
@@ -111,9 +132,9 @@
         </object>
 
         <object class="sizeritem">
-            <flag>wxALIGN_LEFT</flag>
+            <flag>wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL</flag>
             <object class="wxStaticText">
-                <label>net_premium</label>
+                <label>net premium</label>
             </object>
         </object>
         <object class="sizeritem">
@@ -124,9 +145,9 @@
         </object>
 
         <object class="sizeritem">
-            <flag>wxALIGN_LEFT</flag>
+            <flag>wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL</flag>
             <object class="wxStaticText">
-                <label>interest_rate</label>
+                <label>interest rate</label>
             </object>
         </object>
         <object class="sizeritem">
@@ -137,9 +158,9 @@
         </object>
 
         <object class="sizeritem">
-            <flag>wxALIGN_LEFT</flag>
+            <flag>wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL</flag>
             <object class="wxStaticText">
-                <label>interest_credit</label>
+                <label>interest credit</label>
             </object>
         </object>
         <object class="sizeritem">
@@ -150,7 +171,7 @@
         </object>
 
         <object class="sizeritem">
-            <flag>wxALIGN_LEFT</flag>
+            <flag>wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL</flag>
             <object class="wxStaticText">
                 <label>withdrawal</label>
             </object>
@@ -162,8 +183,26 @@
             </object>
         </object>
 
+    </object><!-- wxFlexGridSizer -->
+            </object><!-- sizeritem -->
+        </object><!-- wxStaticBoxSizer -->
+    </object><!-- sizeritem -->
+
+    <object class="sizeritem">
+        <flag>wxALIGN_LEFT|wxALIGN_TOP|wxBOTTOM|wxLEFT|wxRIGHT|wxEXPAND</flag>
+        <border>6</border>
+        <object class="wxStaticBoxSizer">
+            <object class="sizeritem">
+                <flag>wxALL</flag>
+                <border>4</border>
+    <object class="wxFlexGridSizer">
+        <cols>2</cols>
+        <rows>0</rows>
+        <hgap>8</hgap>
+        <vgap>4</vgap>
+
         <object class="sizeritem">
-            <flag>wxALIGN_LEFT</flag>
+            <flag>wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL</flag>
             <object class="wxStaticText">
                 <label>loan</label>
             </object>
@@ -176,9 +215,9 @@
         </object>
 
         <object class="sizeritem">
-            <flag>wxALIGN_LEFT</flag>
+            <flag>wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL</flag>
             <object class="wxStaticText">
-                <label>corridor_factor</label>
+                <label>corridor factor</label>
             </object>
         </object>
         <object class="sizeritem">
@@ -189,9 +228,9 @@
         </object>
 
         <object class="sizeritem">
-            <flag>wxALIGN_LEFT</flag>
+            <flag>wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL</flag>
             <object class="wxStaticText">
-                <label>surrender_charge</label>
+                <label>surrender charge</label>
             </object>
         </object>
         <object class="sizeritem">
@@ -202,7 +241,7 @@
         </object>
 
         <object class="sizeritem">
-            <flag>wxALIGN_LEFT</flag>
+            <flag>wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL</flag>
             <object class="wxStaticText">
                 <label>irr</label>
             </object>
@@ -215,9 +254,9 @@
         </object>
 
         <object class="sizeritem">
-            <flag>wxALIGN_LEFT</flag>
+            <flag>wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL</flag>
             <object class="wxStaticText">
-                <label>min_specamt</label>
+                <label>min specamt</label>
             </object>
         </object>
         <object class="sizeritem">
@@ -228,9 +267,9 @@
         </object>
 
         <object class="sizeritem">
-            <flag>wxALIGN_LEFT</flag>
+            <flag>wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL</flag>
             <object class="wxStaticText">
-                <label>max_specamt</label>
+                <label>max specamt</label>
             </object>
         </object>
         <object class="sizeritem">
@@ -241,9 +280,9 @@
         </object>
 
         <object class="sizeritem">
-            <flag>wxALIGN_LEFT</flag>
+            <flag>wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL</flag>
             <object class="wxStaticText">
-                <label>min_premium</label>
+                <label>min premium</label>
             </object>
         </object>
         <object class="sizeritem">
@@ -254,9 +293,9 @@
         </object>
 
         <object class="sizeritem">
-            <flag>wxALIGN_LEFT</flag>
+            <flag>wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL</flag>
             <object class="wxStaticText">
-                <label>max_premium</label>
+                <label>max premium</label>
             </object>
         </object>
         <object class="sizeritem">
@@ -267,9 +306,9 @@
         </object>
 
         <object class="sizeritem">
-            <flag>wxALIGN_LEFT</flag>
+            <flag>wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL</flag>
             <object class="wxStaticText">
-                <label>interest_rate_7702</label>
+                <label>interest rate 7702</label>
             </object>
         </object>
         <object class="sizeritem">
@@ -279,8 +318,46 @@
             </object>
         </object>
 
-    </object>
+    </object><!-- wxFlexGridSizer -->
+            </object><!-- sizeritem -->
+        </object><!-- wxStaticBoxSizer -->
+    </object><!-- sizeritem -->
+
+</object><!-- wxBoxSizer -->
+
+</object><!-- sizeritem -->
+
+<object class="spacer">
+    <option>1</option>
 </object>
 
+</object><!-- wxBoxSizer -->
+
+</object><!-- wxPanel -->
+
+<object class="wxBitmap" name="rounding_view_not_at_all">rounding_view_not_at_all.xpm</object>
+
+<object class="wxBitmap" name="rounding_view_not_at_all_hover">rounding_view_not_at_all_hover.xpm</object>
+
+<object class="wxBitmap" name="rounding_view_not_at_all_selected">rounding_view_not_at_all_selected.xpm</object>
+
+<object class="wxBitmap" name="rounding_view_to_nearest">rounding_view_to_nearest.xpm</object>
+
+<object class="wxBitmap" name="rounding_view_to_nearest_hover">rounding_view_to_nearest_hover.xpm</object>
+
+<object class="wxBitmap" name="rounding_view_to_nearest_selected">rounding_view_to_nearest_selected.xpm</object>
+
+<object class="wxBitmap" name="rounding_view_upward">rounding_view_upward.xpm</object>
+
+<object class="wxBitmap" name="rounding_view_upward_hover">rounding_view_upward_hover.xpm</object>
+
+<object class="wxBitmap" name="rounding_view_upward_selected">rounding_view_upward_selected.xpm</object>
+
+<object class="wxBitmap" name="rounding_view_downward">rounding_view_downward.xpm</object>
+
+<object class="wxBitmap" name="rounding_view_downward_hover">rounding_view_downward_hover.xpm</object>
+
+<object class="wxBitmap" name="rounding_view_downward_selected">rounding_view_downward_selected.xpm</object>
+
 </resource>
 
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/stratified_charges.cpp lmi-editor/stratified_charges.cpp
--- cvs/stratified_charges.cpp	2008-01-10 18:31:47.000000000 +0100
+++ lmi-editor/stratified_charges.cpp	2008-01-30 21:04:28.000000000 +0100
@@ -71,6 +71,25 @@
     :limits_(limits)
     ,values_(values)
 {
+    check_sizes();
+}
+
+//============================================================================
+stratified_entity::~stratified_entity()
+{
+}
+
+//============================================================================
+void stratified_entity::check_everything() const
+{
+    check_not_empty();
+    check_sizes();
+    check_limits();
+}
+
+//============================================================================
+void stratified_entity::check_sizes() const
+{
     if(limits_.size() != values_.size())
         {
         throw std::logic_error("Tiered values and limits of unequal length.");
@@ -78,8 +97,70 @@
 }
 
 //============================================================================
-stratified_entity::~stratified_entity()
+void stratified_entity::check_not_empty() const
+{
+    if(values_.empty())
+        {
+        throw std::logic_error("Empty values array.");
+        }
+}
+
+//============================================================================
+void stratified_entity::check_limits() const
+{
+    check_last_limit();
+    check_limits_positive();
+    check_limits_non_decreasing_order();
+}
+
+//============================================================================
+void stratified_entity::check_last_limit() const
+{
+    check_not_empty();
+    if(!is_highest_representable(limits_.back()))
+        {
+        std::ostringstream oss;
+        oss
+            << "Invalid final band '"
+            << limits_.back()
+            << "' - it should not have any value."
+            ;
+        throw std::logic_error(oss.str());
+        }
+}
+
+//============================================================================
+void stratified_entity::check_limits_positive() const
+{
+    for
+        (std::vector<double>::const_iterator it = limits_.begin()
+        ;it != limits_.end()
+        ;++it
+        )
+        {
+        if(*it < 0.)
+            {
+            throw std::logic_error("All bands must be positive.");
+            }
+        }
+}
+
+//============================================================================
+void stratified_entity::check_limits_non_decreasing_order() const
 {
+    double previous = 0.;
+    for
+        (std::vector<double>::const_iterator it = limits_.begin()
+        ;it != limits_.end()
+        ;++it
+        )
+        {
+        if(*it < previous)
+            {
+            throw std::logic_error("Bands must be in non-decreasing order.");
+            }
+        previous = *it;
+        }
 }
 
 //============================================================================
@@ -94,14 +175,21 @@
     return values_;
 }
 
+//============================================================================
+bool stratified_entity::is_highest_representable(double value)
+{
+    // Check if the number is greater than (.999 * DBL_MAX).
+    // Don't assert equality with DBL_MAX because the default
+    // precision of the stream >> and << operators for doubles hasn't been
+    // changed, so exact equality will not obtain.
+    return (.999 * DBL_MAX) < value;
+}
+
 // INELEGANT !! Just omit the last band when the product editor is
 // replaced.
 //
 // When reading or writing the entities, assert that the last limit is
-// greater than (.999 * DBL_MAX): in effect, the highest representable
-// number. Don't assert equality with DBL_MAX because the default
-// precision of the stream >> and << operators for doubles hasn't been
-// changed, so exact equality will not obtain.
+// the highest representable number.
 
 //============================================================================
 void stratified_entity::read(std::istream& is)
@@ -129,15 +217,13 @@
         }
     LMI_ASSERT(vector_size == limits_.size());
 
-    LMI_ASSERT(values_.size() == limits_.size());
-    LMI_ASSERT((.999 * DBL_MAX) < limits_.back());
+    check_everything();
 }
 
 //============================================================================
 void stratified_entity::write(std::ostream& os) const
 {
-    LMI_ASSERT(values_.size() == limits_.size());
-    LMI_ASSERT((.999 * DBL_MAX) < limits_.back());
+    check_everything();
 
     std::vector<double>::const_iterator i;
 
@@ -451,7 +537,7 @@
     else
         {
         stratified_entity const& z = raw_entity(table);
-        LMI_ASSERT(!z.values().empty());
+        z.check_not_empty();
         return *std::min_element(z.values().begin(), z.values().end());
         }
 }
@@ -470,27 +556,32 @@
         }
     std::ifstream is(filename.c_str());
 
-    is >> raw_entity(e_curr_sepacct_load_banded_by_premium  );
-    is >> raw_entity(e_guar_sepacct_load_banded_by_premium  );
-    is >> raw_entity(e_curr_m_and_e_tiered_by_assets        );
-    is >> raw_entity(e_guar_m_and_e_tiered_by_assets        );
-    is >> raw_entity(e_asset_based_comp_tiered_by_assets    );
-    is >> raw_entity(e_investment_mgmt_fee_tiered_by_assets );
-    is >> raw_entity(e_curr_sepacct_load_tiered_by_assets   );
-    is >> raw_entity(e_guar_sepacct_load_tiered_by_assets   );
-    is >> raw_entity(e_tiered_ak_premium_tax                );
-    is >> raw_entity(e_tiered_de_premium_tax                );
-    is >> raw_entity(e_tiered_sd_premium_tax                );
-
-    if(!is.good())
+    try
         {
+        read_entity(is, e_curr_sepacct_load_banded_by_premium );
+        read_entity(is, e_guar_sepacct_load_banded_by_premium );
+        read_entity(is, e_curr_m_and_e_tiered_by_assets       );
+        read_entity(is, e_guar_m_and_e_tiered_by_assets       );
+        read_entity(is, e_asset_based_comp_tiered_by_assets   );
+        read_entity(is, e_investment_mgmt_fee_tiered_by_assets);
+        read_entity(is, e_curr_sepacct_load_tiered_by_assets  );
+        read_entity(is, e_guar_sepacct_load_tiered_by_assets  );
+        read_entity(is, e_tiered_ak_premium_tax               );
+        read_entity(is, e_tiered_de_premium_tax               );
+        read_entity(is, e_tiered_sd_premium_tax               );
+        }
+    catch(std::exception const& e)
+        {
+        std::ostringstream oss;
         fatal_error()
-            << "Unexpected end of stratified-data file '"
+            << "Error in '"
             << filename
-            << "'. Try reinstalling."
+            << "': "
+            << e.what()
             << LMI_FLUSH
             ;
         }
+
     std::string dummy;
     is >> dummy;
     if(!is.eof())
@@ -505,21 +596,66 @@
 }
 
 //============================================================================
+void stratified_charges::read_entity(std::istream& is, e_stratified stratified)
+{
+    // TODO ?? Add human readable e_stratified entity names to error messages.
+    try
+        {
+        is >> raw_entity(stratified);
+        }
+    catch(std::exception const& e)
+        {
+        std::stringstream oss;
+        oss
+            << "Error reading '"
+            << stratified
+            << "' entity: "
+            << e.what()
+            ;
+        throw std::runtime_error(oss.str());
+        }
+    if(!is.good())
+        {
+        std::stringstream oss;
+        oss
+            << "Unexpected end of stratified-data while reading '"
+            << stratified
+            << "' entity."
+            ;
+        throw std::runtime_error(oss.str());
+        }
+}
+
+//============================================================================
 void stratified_charges::write(std::string const& filename) const
 {
     std::ofstream os(filename.c_str());
 
-    os << raw_entity(e_curr_sepacct_load_banded_by_premium  );
-    os << raw_entity(e_guar_sepacct_load_banded_by_premium  );
-    os << raw_entity(e_curr_m_and_e_tiered_by_assets        );
-    os << raw_entity(e_guar_m_and_e_tiered_by_assets        );
-    os << raw_entity(e_asset_based_comp_tiered_by_assets    );
-    os << raw_entity(e_investment_mgmt_fee_tiered_by_assets );
-    os << raw_entity(e_curr_sepacct_load_tiered_by_assets   );
-    os << raw_entity(e_guar_sepacct_load_tiered_by_assets   );
-    os << raw_entity(e_tiered_ak_premium_tax                );
-    os << raw_entity(e_tiered_de_premium_tax                );
-    os << raw_entity(e_tiered_sd_premium_tax                );
+    try
+        {
+        write_entity(os, e_curr_sepacct_load_banded_by_premium );
+        write_entity(os, e_guar_sepacct_load_banded_by_premium );
+        write_entity(os, e_curr_m_and_e_tiered_by_assets       );
+        write_entity(os, e_guar_m_and_e_tiered_by_assets       );
+        write_entity(os, e_asset_based_comp_tiered_by_assets   );
+        write_entity(os, e_investment_mgmt_fee_tiered_by_assets);
+        write_entity(os, e_curr_sepacct_load_tiered_by_assets  );
+        write_entity(os, e_guar_sepacct_load_tiered_by_assets  );
+        write_entity(os, e_tiered_ak_premium_tax               );
+        write_entity(os, e_tiered_de_premium_tax               );
+        write_entity(os, e_tiered_sd_premium_tax               );
+        }
+    catch(std::exception const& e)
+        {
+        std::ostringstream oss;
+        fatal_error()
+            << "Error writing into '"
+            << filename
+            << "': "
+            << e.what()
+            << LMI_FLUSH
+            ;
+        }
 
     if(!os.good())
         {
@@ -533,6 +669,40 @@
 }
 
 //============================================================================
+void stratified_charges::write_entity
+    (std::ostream& os
+    ,e_stratified stratified
+    ) const
+{
+    // TODO ?? Add human readable e_stratified entity names to error messages.
+    try
+        {
+        os << raw_entity(stratified);
+        }
+    catch(std::exception const& e)
+        {
+        std::stringstream oss;
+        oss
+            << "Error writing '"
+            << stratified
+            << "' entity: "
+            << e.what()
+            ;
+        throw std::runtime_error(oss.str());
+        }
+    if(!os.good())
+        {
+        std::stringstream oss;
+        oss
+            << "invalid output when writing stratified-data for '"
+            << stratified
+            << "' entity."
+            ;
+        throw std::runtime_error(oss.str());
+        }
+}
+
+//============================================================================
 void stratified_charges::write_stratified_files()
 {
     stratified_charges foo;
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/stratified_charges.hpp lmi-editor/stratified_charges.hpp
--- cvs/stratified_charges.hpp	2008-01-10 18:31:47.000000000 +0100
+++ lmi-editor/stratified_charges.hpp	2008-01-30 21:04:28.000000000 +0100
@@ -77,6 +77,18 @@
     void read(std::istream& is);
     void write(std::ostream& os) const;
 
+    // Determine if the value is the highest representable double number.
+    static bool is_highest_representable(double);
+
+    // These methods throw std::logic_error if data is not valid.
+    void check_everything() const;
+    void check_last_limit() const;
+    void check_limits() const;
+    void check_limits_positive() const;
+    void check_limits_non_decreasing_order() const;
+    void check_not_empty() const;
+    void check_sizes() const;
+
   private:
     std::vector<double> const& limits() const;
     std::vector<double> const& values() const;
@@ -150,6 +162,9 @@
     void read (std::string const& filename);
     void write(std::string const& filename) const;
 
+    void read_entity(std::istream&, e_stratified);
+    void write_entity(std::ostream&, e_stratified) const;
+
     double banded_curr_sepacct_load
         (double assets
         ,double premium
